t / test-lib.shon commit Merge branch 'rt/zlib-smaller-window' (6fcb384)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset $(perl -e '
  48        my @env = keys %ENV;
  49        my $ok = join("|", qw(
  50                TRACE
  51                DEBUG
  52                USE_LOOKUP
  53                TEST
  54                .*_TEST
  55                PROVE
  56                VALGRIND
  57        ));
  58        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  59        print join("\n", @vars);
  60')
  61GIT_AUTHOR_EMAIL=author@example.com
  62GIT_AUTHOR_NAME='A U Thor'
  63GIT_COMMITTER_EMAIL=committer@example.com
  64GIT_COMMITTER_NAME='C O Mitter'
  65GIT_MERGE_VERBOSITY=5
  66export GIT_MERGE_VERBOSITY
  67export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  68export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  69export EDITOR
  70
  71# Protect ourselves from common misconfiguration to export
  72# CDPATH into the environment
  73unset CDPATH
  74
  75unset GREP_OPTIONS
  76
  77case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  78        1|2|true)
  79                echo "* warning: Some tests will not work if GIT_TRACE" \
  80                        "is set as to trace on STDERR ! *"
  81                echo "* warning: Please set GIT_TRACE to something" \
  82                        "other than 1, 2 or true ! *"
  83                ;;
  84esac
  85
  86# Convenience
  87#
  88# A regexp to match 5 and 40 hexdigits
  89_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  90_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  91
  92# Zero SHA-1
  93_z40=0000000000000000000000000000000000000000
  94
  95# Line feed
  96LF='
  97'
  98
  99# Each test should start with something like this, after copyright notices:
 100#
 101# test_description='Description of this test...
 102# This test checks if command xyzzy does the right thing...
 103# '
 104# . ./test-lib.sh
 105[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 106                TERM=$ORIGINAL_TERM &&
 107                export TERM &&
 108                [ -t 1 ] &&
 109                tput bold >/dev/null 2>&1 &&
 110                tput setaf 1 >/dev/null 2>&1 &&
 111                tput sgr0 >/dev/null 2>&1
 112        ) &&
 113        color=t
 114
 115while test "$#" -ne 0
 116do
 117        case "$1" in
 118        -d|--d|--de|--deb|--debu|--debug)
 119                debug=t; shift ;;
 120        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 121                immediate=t; shift ;;
 122        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 123                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 124        -h|--h|--he|--hel|--help)
 125                help=t; shift ;;
 126        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 127                verbose=t; shift ;;
 128        -q|--q|--qu|--qui|--quie|--quiet)
 129                # Ignore --quiet under a TAP::Harness. Saying how many tests
 130                # passed without the ok/not ok details is always an error.
 131                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 132        --with-dashes)
 133                with_dashes=t; shift ;;
 134        --no-color)
 135                color=; shift ;;
 136        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 137                valgrind=t; verbose=t; shift ;;
 138        --tee)
 139                shift ;; # was handled already
 140        --root=*)
 141                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 142                shift ;;
 143        *)
 144                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 145        esac
 146done
 147
 148if test -n "$color"; then
 149        say_color () {
 150                (
 151                TERM=$ORIGINAL_TERM
 152                export TERM
 153                case "$1" in
 154                        error) tput bold; tput setaf 1;; # bold red
 155                        skip)  tput bold; tput setaf 2;; # bold green
 156                        pass)  tput setaf 2;;            # green
 157                        info)  tput setaf 3;;            # brown
 158                        *) test -n "$quiet" && return;;
 159                esac
 160                shift
 161                printf "%s" "$*"
 162                tput sgr0
 163                echo
 164                )
 165        }
 166else
 167        say_color() {
 168                test -z "$1" && test -n "$quiet" && return
 169                shift
 170                echo "$*"
 171        }
 172fi
 173
 174error () {
 175        say_color error "error: $*"
 176        GIT_EXIT_OK=t
 177        exit 1
 178}
 179
 180say () {
 181        say_color info "$*"
 182}
 183
 184test "${test_description}" != "" ||
 185error "Test script did not set test_description."
 186
 187if test "$help" = "t"
 188then
 189        echo "$test_description"
 190        exit 0
 191fi
 192
 193exec 5>&1
 194if test "$verbose" = "t"
 195then
 196        exec 4>&2 3>&1
 197else
 198        exec 4>/dev/null 3>/dev/null
 199fi
 200
 201test_failure=0
 202test_count=0
 203test_fixed=0
 204test_broken=0
 205test_success=0
 206
 207test_external_has_tap=0
 208
 209die () {
 210        code=$?
 211        if test -n "$GIT_EXIT_OK"
 212        then
 213                exit $code
 214        else
 215                echo >&5 "FATAL: Unexpected exit with code $code"
 216                exit 1
 217        fi
 218}
 219
 220GIT_EXIT_OK=
 221trap 'die' EXIT
 222
 223# The semantics of the editor variables are that of invoking
 224# sh -c "$EDITOR \"$@\"" files ...
 225#
 226# If our trash directory contains shell metacharacters, they will be
 227# interpreted if we just set $EDITOR directly, so do a little dance with
 228# environment variables to work around this.
 229#
 230# In particular, quoting isn't enough, as the path may contain the same quote
 231# that we're using.
 232test_set_editor () {
 233        FAKE_EDITOR="$1"
 234        export FAKE_EDITOR
 235        EDITOR='"$FAKE_EDITOR"'
 236        export EDITOR
 237}
 238
 239test_decode_color () {
 240        awk '
 241                function name(n) {
 242                        if (n == 0) return "RESET";
 243                        if (n == 1) return "BOLD";
 244                        if (n == 30) return "BLACK";
 245                        if (n == 31) return "RED";
 246                        if (n == 32) return "GREEN";
 247                        if (n == 33) return "YELLOW";
 248                        if (n == 34) return "BLUE";
 249                        if (n == 35) return "MAGENTA";
 250                        if (n == 36) return "CYAN";
 251                        if (n == 37) return "WHITE";
 252                        if (n == 40) return "BLACK";
 253                        if (n == 41) return "BRED";
 254                        if (n == 42) return "BGREEN";
 255                        if (n == 43) return "BYELLOW";
 256                        if (n == 44) return "BBLUE";
 257                        if (n == 45) return "BMAGENTA";
 258                        if (n == 46) return "BCYAN";
 259                        if (n == 47) return "BWHITE";
 260                }
 261                {
 262                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 263                                printf "%s<", substr($0, 1, RSTART-1);
 264                                codes = substr($0, RSTART+2, RLENGTH-3);
 265                                if (length(codes) == 0)
 266                                        printf "%s", name(0)
 267                                else {
 268                                        n = split(codes, ary, ";");
 269                                        sep = "";
 270                                        for (i = 1; i <= n; i++) {
 271                                                printf "%s%s", sep, name(ary[i]);
 272                                                sep = ";"
 273                                        }
 274                                }
 275                                printf ">";
 276                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 277                        }
 278                        print
 279                }
 280        '
 281}
 282
 283nul_to_q () {
 284        perl -pe 'y/\000/Q/'
 285}
 286
 287q_to_nul () {
 288        perl -pe 'y/Q/\000/'
 289}
 290
 291q_to_cr () {
 292        tr Q '\015'
 293}
 294
 295q_to_tab () {
 296        tr Q '\011'
 297}
 298
 299append_cr () {
 300        sed -e 's/$/Q/' | tr Q '\015'
 301}
 302
 303remove_cr () {
 304        tr '\015' Q | sed -e 's/Q$//'
 305}
 306
 307# In some bourne shell implementations, the "unset" builtin returns
 308# nonzero status when a variable to be unset was not set in the first
 309# place.
 310#
 311# Use sane_unset when that should not be considered an error.
 312
 313sane_unset () {
 314        unset "$@"
 315        return 0
 316}
 317
 318test_tick () {
 319        if test -z "${test_tick+set}"
 320        then
 321                test_tick=1112911993
 322        else
 323                test_tick=$(($test_tick + 60))
 324        fi
 325        GIT_COMMITTER_DATE="$test_tick -0700"
 326        GIT_AUTHOR_DATE="$test_tick -0700"
 327        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 328}
 329
 330# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 331#
 332# This will commit a file with the given contents and the given commit
 333# message.  It will also add a tag with <message> as name.
 334#
 335# Both <file> and <contents> default to <message>.
 336
 337test_commit () {
 338        file=${2:-"$1.t"}
 339        echo "${3-$1}" > "$file" &&
 340        git add "$file" &&
 341        test_tick &&
 342        git commit -m "$1" &&
 343        git tag "$1"
 344}
 345
 346# Call test_merge with the arguments "<message> <commit>", where <commit>
 347# can be a tag pointing to the commit-to-merge.
 348
 349test_merge () {
 350        test_tick &&
 351        git merge -m "$1" "$2" &&
 352        git tag "$1"
 353}
 354
 355# This function helps systems where core.filemode=false is set.
 356# Use it instead of plain 'chmod +x' to set or unset the executable bit
 357# of a file in the working directory and add it to the index.
 358
 359test_chmod () {
 360        chmod "$@" &&
 361        git update-index --add "--chmod=$@"
 362}
 363
 364# Use test_set_prereq to tell that a particular prerequisite is available.
 365# The prerequisite can later be checked for in two ways:
 366#
 367# - Explicitly using test_have_prereq.
 368#
 369# - Implicitly by specifying the prerequisite tag in the calls to
 370#   test_expect_{success,failure,code}.
 371#
 372# The single parameter is the prerequisite tag (a simple word, in all
 373# capital letters by convention).
 374
 375test_set_prereq () {
 376        satisfied="$satisfied$1 "
 377}
 378satisfied=" "
 379
 380test_have_prereq () {
 381        # prerequisites can be concatenated with ','
 382        save_IFS=$IFS
 383        IFS=,
 384        set -- $*
 385        IFS=$save_IFS
 386
 387        total_prereq=0
 388        ok_prereq=0
 389        missing_prereq=
 390
 391        for prerequisite
 392        do
 393                total_prereq=$(($total_prereq + 1))
 394                case $satisfied in
 395                *" $prerequisite "*)
 396                        ok_prereq=$(($ok_prereq + 1))
 397                        ;;
 398                *)
 399                        # Keep a list of missing prerequisites
 400                        if test -z "$missing_prereq"
 401                        then
 402                                missing_prereq=$prerequisite
 403                        else
 404                                missing_prereq="$prerequisite,$missing_prereq"
 405                        fi
 406                esac
 407        done
 408
 409        test $total_prereq = $ok_prereq
 410}
 411
 412test_declared_prereq () {
 413        case ",$test_prereq," in
 414        *,$1,*)
 415                return 0
 416                ;;
 417        esac
 418        return 1
 419}
 420
 421# You are not expected to call test_ok_ and test_failure_ directly, use
 422# the text_expect_* functions instead.
 423
 424test_ok_ () {
 425        test_success=$(($test_success + 1))
 426        say_color "" "ok $test_count - $@"
 427}
 428
 429test_failure_ () {
 430        test_failure=$(($test_failure + 1))
 431        say_color error "not ok - $test_count $1"
 432        shift
 433        echo "$@" | sed -e 's/^/#       /'
 434        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 435}
 436
 437test_known_broken_ok_ () {
 438        test_fixed=$(($test_fixed+1))
 439        say_color "" "ok $test_count - $@ # TODO known breakage"
 440}
 441
 442test_known_broken_failure_ () {
 443        test_broken=$(($test_broken+1))
 444        say_color skip "not ok $test_count - $@ # TODO known breakage"
 445}
 446
 447test_debug () {
 448        test "$debug" = "" || eval "$1"
 449}
 450
 451test_eval_ () {
 452        # This is a separate function because some tests use
 453        # "return" to end a test_expect_success block early.
 454        eval >&3 2>&4 "$*"
 455}
 456
 457test_run_ () {
 458        test_cleanup=:
 459        expecting_failure=$2
 460        test_eval_ "$1"
 461        eval_ret=$?
 462
 463        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 464        then
 465                test_eval_ "$test_cleanup"
 466        fi
 467        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 468                echo ""
 469        fi
 470        return "$eval_ret"
 471}
 472
 473test_skip () {
 474        test_count=$(($test_count+1))
 475        to_skip=
 476        for skp in $GIT_SKIP_TESTS
 477        do
 478                case $this_test.$test_count in
 479                $skp)
 480                        to_skip=t
 481                        break
 482                esac
 483        done
 484        if test -z "$to_skip" && test -n "$test_prereq" &&
 485           ! test_have_prereq "$test_prereq"
 486        then
 487                to_skip=t
 488        fi
 489        case "$to_skip" in
 490        t)
 491                of_prereq=
 492                if test "$missing_prereq" != "$test_prereq"
 493                then
 494                        of_prereq=" of $test_prereq"
 495                fi
 496
 497                say_color skip >&3 "skipping test: $@"
 498                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 499                : true
 500                ;;
 501        *)
 502                false
 503                ;;
 504        esac
 505}
 506
 507test_expect_failure () {
 508        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 509        test "$#" = 2 ||
 510        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 511        export test_prereq
 512        if ! test_skip "$@"
 513        then
 514                say >&3 "checking known breakage: $2"
 515                if test_run_ "$2" expecting_failure
 516                then
 517                        test_known_broken_ok_ "$1"
 518                else
 519                        test_known_broken_failure_ "$1"
 520                fi
 521        fi
 522        echo >&3 ""
 523}
 524
 525test_expect_success () {
 526        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 527        test "$#" = 2 ||
 528        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 529        export test_prereq
 530        if ! test_skip "$@"
 531        then
 532                say >&3 "expecting success: $2"
 533                if test_run_ "$2"
 534                then
 535                        test_ok_ "$1"
 536                else
 537                        test_failure_ "$@"
 538                fi
 539        fi
 540        echo >&3 ""
 541}
 542
 543# test_external runs external test scripts that provide continuous
 544# test output about their progress, and succeeds/fails on
 545# zero/non-zero exit code.  It outputs the test output on stdout even
 546# in non-verbose mode, and announces the external script with "# run
 547# <n>: ..." before running it.  When providing relative paths, keep in
 548# mind that all scripts run in "trash directory".
 549# Usage: test_external description command arguments...
 550# Example: test_external 'Perl API' perl ../path/to/test.pl
 551test_external () {
 552        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 553        test "$#" = 3 ||
 554        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 555        descr="$1"
 556        shift
 557        export test_prereq
 558        if ! test_skip "$descr" "$@"
 559        then
 560                # Announce the script to reduce confusion about the
 561                # test output that follows.
 562                say_color "" "# run $test_count: $descr ($*)"
 563                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 564                # to be able to use them in script
 565                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 566                # Run command; redirect its stderr to &4 as in
 567                # test_run_, but keep its stdout on our stdout even in
 568                # non-verbose mode.
 569                "$@" 2>&4
 570                if [ "$?" = 0 ]
 571                then
 572                        if test $test_external_has_tap -eq 0; then
 573                                test_ok_ "$descr"
 574                        else
 575                                say_color "" "# test_external test $descr was ok"
 576                                test_success=$(($test_success + 1))
 577                        fi
 578                else
 579                        if test $test_external_has_tap -eq 0; then
 580                                test_failure_ "$descr" "$@"
 581                        else
 582                                say_color error "# test_external test $descr failed: $@"
 583                                test_failure=$(($test_failure + 1))
 584                        fi
 585                fi
 586        fi
 587}
 588
 589# Like test_external, but in addition tests that the command generated
 590# no output on stderr.
 591test_external_without_stderr () {
 592        # The temporary file has no (and must have no) security
 593        # implications.
 594        tmp=${TMPDIR:-/tmp}
 595        stderr="$tmp/git-external-stderr.$$.tmp"
 596        test_external "$@" 4> "$stderr"
 597        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 598        descr="no stderr: $1"
 599        shift
 600        say >&3 "# expecting no stderr from previous command"
 601        if [ ! -s "$stderr" ]; then
 602                rm "$stderr"
 603
 604                if test $test_external_has_tap -eq 0; then
 605                        test_ok_ "$descr"
 606                else
 607                        say_color "" "# test_external_without_stderr test $descr was ok"
 608                        test_success=$(($test_success + 1))
 609                fi
 610        else
 611                if [ "$verbose" = t ]; then
 612                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 613                else
 614                        output=
 615                fi
 616                # rm first in case test_failure exits.
 617                rm "$stderr"
 618                if test $test_external_has_tap -eq 0; then
 619                        test_failure_ "$descr" "$@" "$output"
 620                else
 621                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 622                        test_failure=$(($test_failure + 1))
 623                fi
 624        fi
 625}
 626
 627# debugging-friendly alternatives to "test [-f|-d|-e]"
 628# The commands test the existence or non-existence of $1. $2 can be
 629# given to provide a more precise diagnosis.
 630test_path_is_file () {
 631        if ! [ -f "$1" ]
 632        then
 633                echo "File $1 doesn't exist. $*"
 634                false
 635        fi
 636}
 637
 638test_path_is_dir () {
 639        if ! [ -d "$1" ]
 640        then
 641                echo "Directory $1 doesn't exist. $*"
 642                false
 643        fi
 644}
 645
 646test_path_is_missing () {
 647        if [ -e "$1" ]
 648        then
 649                echo "Path exists:"
 650                ls -ld "$1"
 651                if [ $# -ge 1 ]; then
 652                        echo "$*"
 653                fi
 654                false
 655        fi
 656}
 657
 658# test_line_count checks that a file has the number of lines it
 659# ought to. For example:
 660#
 661#       test_expect_success 'produce exactly one line of output' '
 662#               do something >output &&
 663#               test_line_count = 1 output
 664#       '
 665#
 666# is like "test $(wc -l <output) = 1" except that it passes the
 667# output through when the number of lines is wrong.
 668
 669test_line_count () {
 670        if test $# != 3
 671        then
 672                error "bug in the test script: not 3 parameters to test_line_count"
 673        elif ! test $(wc -l <"$3") "$1" "$2"
 674        then
 675                echo "test_line_count: line count for $3 !$1 $2"
 676                cat "$3"
 677                return 1
 678        fi
 679}
 680
 681# This is not among top-level (test_expect_success | test_expect_failure)
 682# but is a prefix that can be used in the test script, like:
 683#
 684#       test_expect_success 'complain and die' '
 685#           do something &&
 686#           do something else &&
 687#           test_must_fail git checkout ../outerspace
 688#       '
 689#
 690# Writing this as "! git checkout ../outerspace" is wrong, because
 691# the failure could be due to a segv.  We want a controlled failure.
 692
 693test_must_fail () {
 694        "$@"
 695        exit_code=$?
 696        if test $exit_code = 0; then
 697                echo >&2 "test_must_fail: command succeeded: $*"
 698                return 1
 699        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 700                echo >&2 "test_must_fail: died by signal: $*"
 701                return 1
 702        elif test $exit_code = 127; then
 703                echo >&2 "test_must_fail: command not found: $*"
 704                return 1
 705        fi
 706        return 0
 707}
 708
 709# Similar to test_must_fail, but tolerates success, too.  This is
 710# meant to be used in contexts like:
 711#
 712#       test_expect_success 'some command works without configuration' '
 713#               test_might_fail git config --unset all.configuration &&
 714#               do something
 715#       '
 716#
 717# Writing "git config --unset all.configuration || :" would be wrong,
 718# because we want to notice if it fails due to segv.
 719
 720test_might_fail () {
 721        "$@"
 722        exit_code=$?
 723        if test $exit_code -gt 129 -a $exit_code -le 192; then
 724                echo >&2 "test_might_fail: died by signal: $*"
 725                return 1
 726        elif test $exit_code = 127; then
 727                echo >&2 "test_might_fail: command not found: $*"
 728                return 1
 729        fi
 730        return 0
 731}
 732
 733# Similar to test_must_fail and test_might_fail, but check that a
 734# given command exited with a given exit code. Meant to be used as:
 735#
 736#       test_expect_success 'Merge with d/f conflicts' '
 737#               test_expect_code 1 git merge "merge msg" B master
 738#       '
 739
 740test_expect_code () {
 741        want_code=$1
 742        shift
 743        "$@"
 744        exit_code=$?
 745        if test $exit_code = $want_code
 746        then
 747                return 0
 748        fi
 749
 750        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 751        return 1
 752}
 753
 754# test_cmp is a helper function to compare actual and expected output.
 755# You can use it like:
 756#
 757#       test_expect_success 'foo works' '
 758#               echo expected >expected &&
 759#               foo >actual &&
 760#               test_cmp expected actual
 761#       '
 762#
 763# This could be written as either "cmp" or "diff -u", but:
 764# - cmp's output is not nearly as easy to read as diff -u
 765# - not all diff versions understand "-u"
 766
 767test_cmp() {
 768        $GIT_TEST_CMP "$@"
 769}
 770
 771# This function can be used to schedule some commands to be run
 772# unconditionally at the end of the test to restore sanity:
 773#
 774#       test_expect_success 'test core.capslock' '
 775#               git config core.capslock true &&
 776#               test_when_finished "git config --unset core.capslock" &&
 777#               hello world
 778#       '
 779#
 780# That would be roughly equivalent to
 781#
 782#       test_expect_success 'test core.capslock' '
 783#               git config core.capslock true &&
 784#               hello world
 785#               git config --unset core.capslock
 786#       '
 787#
 788# except that the greeting and config --unset must both succeed for
 789# the test to pass.
 790#
 791# Note that under --immediate mode, no clean-up is done to help diagnose
 792# what went wrong.
 793
 794test_when_finished () {
 795        test_cleanup="{ $*
 796                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 797}
 798
 799# Most tests can use the created repository, but some may need to create more.
 800# Usage: test_create_repo <directory>
 801test_create_repo () {
 802        test "$#" = 1 ||
 803        error "bug in the test script: not 1 parameter to test-create-repo"
 804        repo="$1"
 805        mkdir -p "$repo"
 806        (
 807                cd "$repo" || error "Cannot setup test environment"
 808                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 809                error "cannot run git init -- have you built things yet?"
 810                mv .git/hooks .git/hooks-disabled
 811        ) || exit
 812}
 813
 814test_done () {
 815        GIT_EXIT_OK=t
 816
 817        if test -z "$HARNESS_ACTIVE"; then
 818                test_results_dir="$TEST_DIRECTORY/test-results"
 819                mkdir -p "$test_results_dir"
 820                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 821
 822                cat >>"$test_results_path" <<-EOF
 823                total $test_count
 824                success $test_success
 825                fixed $test_fixed
 826                broken $test_broken
 827                failed $test_failure
 828
 829                EOF
 830        fi
 831
 832        if test "$test_fixed" != 0
 833        then
 834                say_color pass "# fixed $test_fixed known breakage(s)"
 835        fi
 836        if test "$test_broken" != 0
 837        then
 838                say_color error "# still have $test_broken known breakage(s)"
 839                msg="remaining $(($test_count-$test_broken)) test(s)"
 840        else
 841                msg="$test_count test(s)"
 842        fi
 843        case "$test_failure" in
 844        0)
 845                # Maybe print SKIP message
 846                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 847
 848                if test $test_external_has_tap -eq 0; then
 849                        say_color pass "# passed all $msg"
 850                        say "1..$test_count$skip_all"
 851                fi
 852
 853                test -d "$remove_trash" &&
 854                cd "$(dirname "$remove_trash")" &&
 855                rm -rf "$(basename "$remove_trash")"
 856
 857                exit 0 ;;
 858
 859        *)
 860                if test $test_external_has_tap -eq 0; then
 861                        say_color error "# failed $test_failure among $msg"
 862                        say "1..$test_count"
 863                fi
 864
 865                exit 1 ;;
 866
 867        esac
 868}
 869
 870# Test the binaries we have just built.  The tests are kept in
 871# t/ subdirectory and are run in 'trash directory' subdirectory.
 872if test -z "$TEST_DIRECTORY"
 873then
 874        # We allow tests to override this, in case they want to run tests
 875        # outside of t/, e.g. for running tests on the test library
 876        # itself.
 877        TEST_DIRECTORY=$(pwd)
 878fi
 879GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 880
 881if test -n "$valgrind"
 882then
 883        make_symlink () {
 884                test -h "$2" &&
 885                test "$1" = "$(readlink "$2")" || {
 886                        # be super paranoid
 887                        if mkdir "$2".lock
 888                        then
 889                                rm -f "$2" &&
 890                                ln -s "$1" "$2" &&
 891                                rm -r "$2".lock
 892                        else
 893                                while test -d "$2".lock
 894                                do
 895                                        say "Waiting for lock on $2."
 896                                        sleep 1
 897                                done
 898                        fi
 899                }
 900        }
 901
 902        make_valgrind_symlink () {
 903                # handle only executables, unless they are shell libraries that
 904                # need to be in the exec-path.  We will just use "#!" as a
 905                # guess for a shell-script, since we have no idea what the user
 906                # may have configured as the shell path.
 907                test -x "$1" ||
 908                test "#!" = "$(head -c 2 <"$1")" ||
 909                return;
 910
 911                base=$(basename "$1")
 912                symlink_target=$GIT_BUILD_DIR/$base
 913                # do not override scripts
 914                if test -x "$symlink_target" &&
 915                    test ! -d "$symlink_target" &&
 916                    test "#!" != "$(head -c 2 < "$symlink_target")"
 917                then
 918                        symlink_target=../valgrind.sh
 919                fi
 920                case "$base" in
 921                *.sh|*.perl)
 922                        symlink_target=../unprocessed-script
 923                esac
 924                # create the link, or replace it if it is out of date
 925                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 926        }
 927
 928        # override all git executables in TEST_DIRECTORY/..
 929        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 930        mkdir -p "$GIT_VALGRIND"/bin
 931        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 932        do
 933                make_valgrind_symlink $file
 934        done
 935        OLDIFS=$IFS
 936        IFS=:
 937        for path in $PATH
 938        do
 939                ls "$path"/git-* 2> /dev/null |
 940                while read file
 941                do
 942                        make_valgrind_symlink "$file"
 943                done
 944        done
 945        IFS=$OLDIFS
 946        PATH=$GIT_VALGRIND/bin:$PATH
 947        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 948        export GIT_VALGRIND
 949elif test -n "$GIT_TEST_INSTALLED" ; then
 950        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 951        error "Cannot run git from $GIT_TEST_INSTALLED."
 952        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 953        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 954else # normal case, use ../bin-wrappers only unless $with_dashes:
 955        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 956        if ! test -x "$git_bin_dir/git" ; then
 957                if test -z "$with_dashes" ; then
 958                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 959                fi
 960                with_dashes=t
 961        fi
 962        PATH="$git_bin_dir:$PATH"
 963        GIT_EXEC_PATH=$GIT_BUILD_DIR
 964        if test -n "$with_dashes" ; then
 965                PATH="$GIT_BUILD_DIR:$PATH"
 966        fi
 967fi
 968GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 969unset GIT_CONFIG
 970GIT_CONFIG_NOSYSTEM=1
 971GIT_ATTR_NOSYSTEM=1
 972export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 973
 974. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
 975
 976if test -z "$GIT_TEST_CMP"
 977then
 978        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 979        then
 980                GIT_TEST_CMP="$DIFF -c"
 981        else
 982                GIT_TEST_CMP="$DIFF -u"
 983        fi
 984fi
 985
 986GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 987export GITPERLLIB
 988test -d "$GIT_BUILD_DIR"/templates/blt || {
 989        error "You haven't built things yet, have you?"
 990}
 991
 992if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 993then
 994        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 995        export GITPYTHONLIB
 996        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 997                error "You haven't built git_remote_helpers yet, have you?"
 998        }
 999fi
1000
1001if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1002        echo >&2 'You need to build test-chmtime:'
1003        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1004        exit 1
1005fi
1006
1007# Test repository
1008test="trash directory.$(basename "$0" .sh)"
1009test -n "$root" && test="$root/$test"
1010case "$test" in
1011/*) TRASH_DIRECTORY="$test" ;;
1012 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1013esac
1014test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1015rm -fr "$test" || {
1016        GIT_EXIT_OK=t
1017        echo >&5 "FATAL: Cannot prepare test area"
1018        exit 1
1019}
1020
1021HOME="$TRASH_DIRECTORY"
1022export HOME
1023
1024test_create_repo "$test"
1025# Use -P to resolve symlinks in our working directory so that the cwd
1026# in subprocesses like git equals our $PWD (for pathname comparisons).
1027cd -P "$test" || exit 1
1028
1029this_test=${0##*/}
1030this_test=${this_test%%-*}
1031for skp in $GIT_SKIP_TESTS
1032do
1033        case "$this_test" in
1034        $skp)
1035                say_color skip >&3 "skipping test $this_test altogether"
1036                skip_all="skip all tests in $this_test"
1037                test_done
1038        esac
1039done
1040
1041# Provide an implementation of the 'yes' utility
1042yes () {
1043        if test $# = 0
1044        then
1045                y=y
1046        else
1047                y="$*"
1048        fi
1049
1050        while echo "$y"
1051        do
1052                :
1053        done
1054}
1055
1056# Fix some commands on Windows
1057case $(uname -s) in
1058*MINGW*)
1059        # Windows has its own (incompatible) sort and find
1060        sort () {
1061                /usr/bin/sort "$@"
1062        }
1063        find () {
1064                /usr/bin/find "$@"
1065        }
1066        sum () {
1067                md5sum "$@"
1068        }
1069        # git sees Windows-style pwd
1070        pwd () {
1071                builtin pwd -W
1072        }
1073        # no POSIX permissions
1074        # backslashes in pathspec are converted to '/'
1075        # exec does not inherit the PID
1076        test_set_prereq MINGW
1077        test_set_prereq SED_STRIPS_CR
1078        ;;
1079*CYGWIN*)
1080        test_set_prereq POSIXPERM
1081        test_set_prereq EXECKEEPSPID
1082        test_set_prereq NOT_MINGW
1083        test_set_prereq SED_STRIPS_CR
1084        ;;
1085*)
1086        test_set_prereq POSIXPERM
1087        test_set_prereq BSLASHPSPEC
1088        test_set_prereq EXECKEEPSPID
1089        test_set_prereq NOT_MINGW
1090        ;;
1091esac
1092
1093test -z "$NO_PERL" && test_set_prereq PERL
1094test -z "$NO_PYTHON" && test_set_prereq PYTHON
1095test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1096
1097# Can we rely on git's output in the C locale?
1098if test -n "$GETTEXT_POISON"
1099then
1100        GIT_GETTEXT_POISON=YesPlease
1101        export GIT_GETTEXT_POISON
1102else
1103        test_set_prereq C_LOCALE_OUTPUT
1104fi
1105
1106# Use this instead of test_cmp to compare files that contain expected and
1107# actual output from git commands that can be translated.  When running
1108# under GETTEXT_POISON this pretends that the command produced expected
1109# results.
1110test_i18ncmp () {
1111        test -n "$GETTEXT_POISON" || test_cmp "$@"
1112}
1113
1114# Use this instead of "grep expected-string actual" to see if the
1115# output from a git command that can be translated either contains an
1116# expected string, or does not contain an unwanted one.  When running
1117# under GETTEXT_POISON this pretends that the command produced expected
1118# results.
1119test_i18ngrep () {
1120        if test -n "$GETTEXT_POISON"
1121        then
1122            : # pretend success
1123        elif test "x!" = "x$1"
1124        then
1125                shift
1126                ! grep "$@"
1127        else
1128                grep "$@"
1129        fi
1130}
1131
1132# test whether the filesystem supports symbolic links
1133ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1134rm -f y
1135
1136# When the tests are run as root, permission tests will report that
1137# things are writable when they shouldn't be.
1138test -w / || test_set_prereq SANITY